/*
    This program does not do any of the task work.

    The main() function creates the worker (child)
    processes and passes to them the command line
    parameters that they need.

    The processWorker-child-io.c and processWorker-child-calc.c
    programs do the task work.
*/
#include "printError.h"
#include <stdio.h>
#include <windows.h>

int main(int argc, char *argv[])
{
   #define NUMBER_OF_IO_PROCESSES 0
   #define NUMBER_OF_CALC_PROCESSES 0
   #define NUMBER_OF_PROCESSES 0

   STARTUPINFO startInfo;
   PROCESS_INFORMATION processInfo[NUMBER_OF_PROCESSES];
   HANDLE lpHandlesIO[NUMBER_OF_IO_PROCESSES];
   HANDLE lpHandlesCALC[NUMBER_OF_CALC_PROCESSES];
   int IOprocessCount = 0;
   int CALCprocessCount = 0;

   #define NUMBER_OF_INPUT_FILES 10

   char commandLine[60];

   int beginTime, n;

   /* keep track of when we start working */
   beginTime = GetTickCount();

   /* this loop creates all of the I/O tasks */
   for (n = 0; n < NUMBER_OF_IO_PROCESSES; n++)
   {
      // Create a command line that randomly chooses one of the
      // ten input files, data0.txt through data9.txt, and
      // sequentially numbers the output files as output?.txt
      // where ? is an integer from 1 to NUMBER_OF_IO_PROCESSES.

      // Use CreateProcess, and the constructed command line, to
      // create a child (worker) process. Be sure to error check
      // the call to CreateProcess and you will need to keep track
      // of the process handle returned by CreateProcess (it is
      // needed by WaitForMultipleObjects()).

      // Note: You may want to log some information to the console
      // to help you see what is going on (but don't do any logging
      // from the child process).
   }

   /* this loop create all of the compute tasks */
   for (n = 0; n < NUMBER_OF_CALC_PROCESSES; n++)
   {
      // Create a command line that randomly chooses a multiplier
      // to pass to the child compute process.

      // Use CreateProcess, and the constructed command line, to
      // create a child (worker) process. Be sure to error check
      // the call to CreateProcess, and you will need to keep track
      // of the process handle returned by CreateProcess (it is
      // needed by WaitForMultipleObjects()).

      // Note: You may want to log some information to the console
      // to help you see what is going on (but don't do any logging
      // from the child process).
   }

   /* wait for all child processes to end */
   printf("  waiting for child processes to complete...");
   // NOTE: WaitForMultipleObjects() can only wait on a maximum of 64 objects.
   // To wait on more than 64 I/O processes (and 64 calc processes) you need to
   // call WaitForMultipleObjects() several times. If 64 < IOprocessCount <= 128,
   // call WaitForMultipleObjects() first with 64 as the first paramenter and
   // lpHandlesIO as the second parameter, then call WaitForMultipleObjects() a
   // second time with IOprocessCount-64 as the first parameter and with
   // lpHandlesIO+64 as the second parameter. Similarly if IOprocessCount > 128.
   // In other words, you need to "walk" through the lpHandlesIO[] array in steps
   // of 64 (and the same for the lpHandlesCALC[] array). Also, the calls to
   // WaitForMultipleObjects() should be error checked.
   WaitForMultipleObjects(IOprocessCount, lpHandlesIO, TRUE, INFINITE);
   WaitForMultipleObjects(CALCprocessCount, lpHandlesCALC, TRUE, INFINITE);
   printf("\nAll processes completed.\n");

   /* determine when we finish working */
   printf("%lo\n", GetTickCount()-beginTime);

   return 0;
}
